summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorblsaws <bryan.sullivan@att.com>2016-08-02 12:23:12 -0700
committerblsaws <bryan.sullivan@att.com>2016-08-02 12:23:12 -0700
commit14a6db40ccf9ff160dc9ed2b3ffe0d3729e528c9 (patch)
tree4979b00777516f2f85969b3bbfea5082b7cd69af
parent5f567eb79d5f38ef88587dcfdda462d9585bff62 (diff)
Fix variation in openstack cient output for network show
JIRA: COPPER-4 Change-Id: Ib7aee663b3d402478454c39dd48a4c803815e544 Signed-off-by: blsaws <bryan.sullivan@att.com>
-rw-r--r--tests/adhoc/smoke01.sh352
-rw-r--r--tests/dmz.sh472
-rw-r--r--tests/smtp_ingress.sh344
3 files changed, 584 insertions, 584 deletions
diff --git a/tests/adhoc/smoke01.sh b/tests/adhoc/smoke01.sh
index 5c264f4..bf330d1 100644
--- a/tests/adhoc/smoke01.sh
+++ b/tests/adhoc/smoke01.sh
@@ -1,176 +1,176 @@
-#!/bin/bash
-# Copyright 2015-2016 AT&T Intellectual Property, Inc
-#
-# Licensed under the Apache License, Version 2.0 (the "License");
-# you may not use this file except in compliance with the License.
-# You may obtain a copy of the License at
-#
-# http://www.apache.org/licenses/LICENSE-2.0
-#
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS,
-# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-# See the License for the specific language governing permissions and
-# limitations under the License.
-#
-# What this is: A basic test to validate an OPNFV install. Creates an image,
-# test_public and private networks, a router, and launches two VMs connected to the
-# private network and thru the router, to the internet.
-#
-# Status: this is a work in progress, under test. Automated ping test to the
-# internet and between VMs has not yet been implemented.
-#
-# How to use:
-# Install Congress test server per https://wiki.opnfv.org/copper/academy
-# $ bash ~/git/copper/tests/adhoc/smoke01.sh
-# After test, cleanup with
-# $ bash ~/git/copper/tests/adhoc/smoke01-clean.sh
-
-pass() {
- echo "Hooray!"
- set +x #echo off
- exit 0
-}
-
-# Use this to trigger fail() at the right places
-# if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-fail() {
- echo "Test Failed!"
- set +x
- exit 1
-}
-
-unclean() {
- echo "Unclean environment!"
- fail
-}
-
-if [ $# -eq 1 ]; then
- if [ $1 == "debug" ]; then
- set -x #echo on
- fi
-fi
-
-# Find external network if any, and details
-function get_external_net () {
- echo "Find external network"
- LINE=4
- ID=$(openstack network list | awk "NR==$LINE{print \$2}")
- while [[ $ID ]]
- do
- if [[ $(openstack network show $ID | awk "/ router:external / { print \$4 }") == "External" ]]; then break; fi
- ((LINE+=1))
- ID=$(openstack network list | awk "NR==$LINE{print \$2}")
- done
- if [[ $ID ]]; then
- EXTERNAL_NETWORK_NAME=$(openstack network show $ID | awk "/ name / { print \$4 }")
- EXTERNAL_SUBNET_ID=$(openstack network show $EXTERNAL_NETWORK_NAME | awk "/ subnets / { print \$4 }")
- else
- echo "External network not found"
- echo "Create external network"
- neutron net-create public --router:external
- EXTERNAL_NETWORK_NAME="public"
- echo "Create external subnet"
- neutron subnet-create public 192.168.10.0/24 --name public --enable_dhcp=False --allocation_pool start=192.168.10.6,end=192.168.10.49 --gateway 192.168.10.1
- EXTERNAL_SUBNET_ID=$(openstack subnet show public | awk "/ id / { print \$4 }")
- fi
-}
-
-wget https://git.opnfv.org/cgit/copper/plain/components/congress/install/bash/setenv.sh -O ~/setenv.sh
-source ~/setenv.sh
-
-echo "Create cirros-0.3.3-x86_64 image"
-image=$(openstack image list | awk "/ cirros-0.3.3-x86_64 / { print \$2 }")
-if [ -z $image ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64 --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
-fi
-
-get_external_net
-
-echo "Create floating IP for external subnet"
-FLOATING_IP_ID=$(neutron floatingip-create $EXTERNAL_NETWORK_NAME | awk "/ id / { print \$4 }")
-FLOATING_IP=$(neutron floatingip-show $FLOATING_IP_ID | awk "/ floating_ip_address / { print \$4 }" | cut -d - -f 1)
-# Save ID to pass to cleanup script
-echo "FLOATING_IP_ID=$FLOATING_IP_ID" >/tmp/TEST_VARS.sh
-
-echo "Create internal network"
-neutron net-create internal
-
-echo "Create internal subnet"
-neutron subnet-create internal 10.0.0.0/24 --name internal --gateway 10.0.0.1 --enable-dhcp --allocation-pool start=10.0.0.2,end=10.0.0.254 --dns-nameserver 8.8.8.8
-
-echo "Create router"
-neutron router-create public_router
-
-echo "Create router gateway"
-neutron router-gateway-set public_router $EXTERNAL_NETWORK_NAME
-
-echo "Add router interface for internal network"
-neutron router-interface-add public_router subnet=internal
-
-echo "Wait up to a minute as 'neutron router-interface-add' blocks the neutron-api for some time..."
-COUNTER=1
-RESULT="Failed!"
-until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
- echo "Get the internal network ID: try" $COUNTER
- internal_NET=$(neutron net-list | awk "/ internal / { print \$2 }")
- if [ "$internal_NET" != "" ]; then RESULT="Success!"; fi
- let COUNTER+=1
- sleep 10
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Create smoke01 security group"
-neutron security-group-create smoke01
-
-echo "Add rule to smoke01 security group"
-neutron security-group-rule-create --direction ingress --protocol=TCP --remote-ip-prefix 0.0.0.0/0 --port-range-min=22 --port-range-max=22 smoke01
-neutron security-group-rule-create --direction ingress --protocol=ICMP --remote-ip-prefix 0.0.0.0/0 smoke01
-neutron security-group-rule-create --direction egress --protocol=TCP --remote-ip-prefix 0.0.0.0/0 --port-range-min=22 --port-range-max=22 smoke01
-neutron security-group-rule-create --direction egress --protocol=ICMP --remote-ip-prefix 0.0.0.0/0 smoke01
-
-echo "Create Nova key pair"
-ssh-keygen -f "$HOME/.ssh/known_hosts" -R 192.168.10.6
-nova keypair-add smoke01 > /tmp/smoke01
-chmod 600 /tmp/smoke01
-
-echo "Boot cirros1"
-nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$internal_NET --security-groups smoke01 --key-name smoke01 cirros1
-
-echo "Get cirros1 instance ID"
-test_cirros1_ID=$(openstack server list | awk "/ cirros1 / { print \$2 }")
-
-echo "Wait for cirros1 to go ACTIVE"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- status=$(openstack server show $test_cirros1_ID | awk "/ status / { print \$4 }")
- if [[ "$status" == "ACTIVE" ]]; then RESULT="Test Success!"; fi
- let COUNTER-=1
- sleep 5
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Associate floating IP to cirros1"
-nova floating-ip-associate cirros1 $FLOATING_IP
-
-echo "Boot cirros2"
-nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$internal_NET --security-groups smoke01 cirros2
-
-COUNTER=1
-RESULT="Failed!"
-until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
- echo "Verify internal network connectivity"
- RESULT=$(ssh -i /tmp/smoke01 -x -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no cirros@$FLOATING_IP "ping -c 3 10.0.0.4; exit" | awk "/ 0% packet loss/ { print \$1 }")
- if [ "$RESULT" == "3" ]; then RESULT="Success!"; fi
- let COUNTER+=1
- sleep 10
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Verify public network connectivity"
-RESULT=$(ssh -i /tmp/smoke01 -x -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no cirros@$FLOATING_IP "ping -c 3 8.8.8.8; exit" | awk "/ 0% packet loss/ { print \$1 }")
-if [ "$RESULT" != "3" ]; then fail; fi
-
-set +x #echo off
-
-pass
+#!/bin/bash
+# Copyright 2015-2016 AT&T Intellectual Property, Inc
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# What this is: A basic test to validate an OPNFV install. Creates an image,
+# test_public and private networks, a router, and launches two VMs connected to the
+# private network and thru the router, to the internet.
+#
+# Status: this is a work in progress, under test. Automated ping test to the
+# internet and between VMs has not yet been implemented.
+#
+# How to use:
+# Install Congress test server per https://wiki.opnfv.org/copper/academy
+# $ bash ~/git/copper/tests/adhoc/smoke01.sh
+# After test, cleanup with
+# $ bash ~/git/copper/tests/adhoc/smoke01-clean.sh
+
+pass() {
+ echo "Hooray!"
+ set +x #echo off
+ exit 0
+}
+
+# Use this to trigger fail() at the right places
+# if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+fail() {
+ echo "Test Failed!"
+ set +x
+ exit 1
+}
+
+unclean() {
+ echo "Unclean environment!"
+ fail
+}
+
+if [ $# -eq 1 ]; then
+ if [ $1 == "debug" ]; then
+ set -x #echo on
+ fi
+fi
+
+# Find external network if any, and details
+function get_external_net () {
+ echo "Find external network"
+ LINE=4
+ ID=$(openstack network list | awk "NR==$LINE{print \$2}")
+ while [[ $ID ]]
+ do
+ if [[ $(openstack network show $ID | awk "/ router/ { print \$4 }") == "External" ]]; then break; fi
+ ((LINE+=1))
+ ID=$(openstack network list | awk "NR==$LINE{print \$2}")
+ done
+ if [[ $ID ]]; then
+ EXTERNAL_NETWORK_NAME=$(openstack network show $ID | awk "/ name / { print \$4 }")
+ EXTERNAL_SUBNET_ID=$(openstack network show $EXTERNAL_NETWORK_NAME | awk "/ subnets / { print \$4 }")
+ else
+ echo "External network not found"
+ echo "Create external network"
+ neutron net-create public --router:external
+ EXTERNAL_NETWORK_NAME="public"
+ echo "Create external subnet"
+ neutron subnet-create public 192.168.10.0/24 --name public --enable_dhcp=False --allocation_pool start=192.168.10.6,end=192.168.10.49 --gateway 192.168.10.1
+ EXTERNAL_SUBNET_ID=$(openstack subnet show public | awk "/ id / { print \$4 }")
+ fi
+}
+
+wget https://git.opnfv.org/cgit/copper/plain/components/congress/install/bash/setenv.sh -O ~/setenv.sh
+source ~/setenv.sh
+
+echo "Create cirros-0.3.3-x86_64 image"
+image=$(openstack image list | awk "/ cirros-0.3.3-x86_64 / { print \$2 }")
+if [ -z $image ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64 --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
+fi
+
+get_external_net
+
+echo "Create floating IP for external subnet"
+FLOATING_IP_ID=$(neutron floatingip-create $EXTERNAL_NETWORK_NAME | awk "/ id / { print \$4 }")
+FLOATING_IP=$(neutron floatingip-show $FLOATING_IP_ID | awk "/ floating_ip_address / { print \$4 }" | cut -d - -f 1)
+# Save ID to pass to cleanup script
+echo "FLOATING_IP_ID=$FLOATING_IP_ID" >/tmp/TEST_VARS.sh
+
+echo "Create internal network"
+neutron net-create internal
+
+echo "Create internal subnet"
+neutron subnet-create internal 10.0.0.0/24 --name internal --gateway 10.0.0.1 --enable-dhcp --allocation-pool start=10.0.0.2,end=10.0.0.254 --dns-nameserver 8.8.8.8
+
+echo "Create router"
+neutron router-create public_router
+
+echo "Create router gateway"
+neutron router-gateway-set public_router $EXTERNAL_NETWORK_NAME
+
+echo "Add router interface for internal network"
+neutron router-interface-add public_router subnet=internal
+
+echo "Wait up to a minute as 'neutron router-interface-add' blocks the neutron-api for some time..."
+COUNTER=1
+RESULT="Failed!"
+until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
+ echo "Get the internal network ID: try" $COUNTER
+ internal_NET=$(neutron net-list | awk "/ internal / { print \$2 }")
+ if [ "$internal_NET" != "" ]; then RESULT="Success!"; fi
+ let COUNTER+=1
+ sleep 10
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Create smoke01 security group"
+neutron security-group-create smoke01
+
+echo "Add rule to smoke01 security group"
+neutron security-group-rule-create --direction ingress --protocol=TCP --remote-ip-prefix 0.0.0.0/0 --port-range-min=22 --port-range-max=22 smoke01
+neutron security-group-rule-create --direction ingress --protocol=ICMP --remote-ip-prefix 0.0.0.0/0 smoke01
+neutron security-group-rule-create --direction egress --protocol=TCP --remote-ip-prefix 0.0.0.0/0 --port-range-min=22 --port-range-max=22 smoke01
+neutron security-group-rule-create --direction egress --protocol=ICMP --remote-ip-prefix 0.0.0.0/0 smoke01
+
+echo "Create Nova key pair"
+ssh-keygen -f "$HOME/.ssh/known_hosts" -R 192.168.10.6
+nova keypair-add smoke01 > /tmp/smoke01
+chmod 600 /tmp/smoke01
+
+echo "Boot cirros1"
+nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$internal_NET --security-groups smoke01 --key-name smoke01 cirros1
+
+echo "Get cirros1 instance ID"
+test_cirros1_ID=$(openstack server list | awk "/ cirros1 / { print \$2 }")
+
+echo "Wait for cirros1 to go ACTIVE"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ status=$(openstack server show $test_cirros1_ID | awk "/ status / { print \$4 }")
+ if [[ "$status" == "ACTIVE" ]]; then RESULT="Test Success!"; fi
+ let COUNTER-=1
+ sleep 5
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Associate floating IP to cirros1"
+nova floating-ip-associate cirros1 $FLOATING_IP
+
+echo "Boot cirros2"
+nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$internal_NET --security-groups smoke01 cirros2
+
+COUNTER=1
+RESULT="Failed!"
+until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
+ echo "Verify internal network connectivity"
+ RESULT=$(ssh -i /tmp/smoke01 -x -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no cirros@$FLOATING_IP "ping -c 3 10.0.0.4; exit" | awk "/ 0% packet loss/ { print \$1 }")
+ if [ "$RESULT" == "3" ]; then RESULT="Success!"; fi
+ let COUNTER+=1
+ sleep 10
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Verify public network connectivity"
+RESULT=$(ssh -i /tmp/smoke01 -x -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no cirros@$FLOATING_IP "ping -c 3 8.8.8.8; exit" | awk "/ 0% packet loss/ { print \$1 }")
+if [ "$RESULT" != "3" ]; then fail; fi
+
+set +x #echo off
+
+pass
diff --git a/tests/dmz.sh b/tests/dmz.sh
index 191d6d3..326e04e 100644
--- a/tests/dmz.sh
+++ b/tests/dmz.sh
@@ -1,236 +1,236 @@
-#!/bin/bash
-# Copyright 2015-2016 AT&T Intellectual Property, Inc
-#
-# Licensed under the Apache License, Version 2.0 (the "License");
-# you may not use this file except in compliance with the License.
-# You may obtain a copy of the License at
-#
-# http://www.apache.org/licenses/LICENSE-2.0
-#
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS,
-# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-# See the License for the specific language governing permissions and
-# limitations under the License.
-#
-
-# What this is: An OpenStack Congress policy test. Sets up and validates policy
-# creation and execution for:
-# 1) Identifying VMs connected to a DMZ (currently identified through a
-# specifically-named security group)
-# 2) Identifying VMs connected per (1), which are by policy not allowed to be
-# (currently implemented through an image tag intended to identify images
-# that are "authorized" i.e. tested and secure, to be DMZ-connected)
-# 3) Reactively enforce the dmz placement rule by pausing VMs found to be in
-# violation of the policy.
-#
-# Status: this is a work in progress, under test.
-#
-# Prequisite: OPFNV installed per JOID or Apex installer
-# - OpenStack CLI environment variables setup
-# How to use:
-# # Create Congress policy and resources that exercise policy
-# $ bash dmz.sh
-# # After test, cleanup
-# $ bash dmz-clean.sh
-
-pass() {
- echo "Hooray!"
- set +x #echo off
- exit 0
-}
-
-# Use this to trigger fail() at the right places
-# if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-fail() {
- echo "Test Failed!"
- set +x
- exit 1
-}
-
-unclean() {
- echo "Unclean environment!"
- fail
-}
-
-if [ $# -eq 1 ]; then
- if [ $1 == "debug" ]; then
- set -x #echo on
- fi
-fi
-
-# Find external network if any, and details
-function get_external_net () {
- echo "Find external network"
- LINE=4
- ID=$(openstack network list | awk "NR==$LINE{print \$2}")
- while [[ $ID ]]
- do
- if [[ $(openstack network show $ID | awk "/ router:external / { print \$4 }") == "External" ]]; then break; fi
- ((LINE+=1))
- ID=$(openstack network list | awk "NR==$LINE{print \$2}")
- done
- if [[ $ID ]]; then
- EXTERNAL_NETWORK_NAME=$(openstack network show $ID | awk "/ name / { print \$4 }")
- EXTERNAL_SUBNET_ID=$(openstack network show $EXTERNAL_NETWORK_NAME | awk "/ subnets / { print \$4 }")
- else
- echo "External network not found"
- echo "Create external network"
- neutron net-create public --router:external
- EXTERNAL_NETWORK_NAME="public"
- echo "Create external subnet"
- neutron subnet-create public 192.168.10.0/24 --name public --enable_dhcp=False --allocation_pool start=192.168.10.6,end=192.168.10.49 --gateway 192.168.10.1
- EXTERNAL_SUBNET_ID=$(openstack subnet show public | awk "/ id / { print \$4 }")
- fi
-}
-
-echo "Create Congress policy 'test'"
-if [ $(openstack congress policy show test | awk "/ id / { print \$4 }") ]; then unclean; fi
-openstack congress policy create test
-
-echo "Create dmz_server rule in policy 'test'"
-openstack congress policy rule create test "dmz_server(x) :- nova:servers(id=x,status='ACTIVE'), neutronv2:ports(id, device_id, status='ACTIVE'), neutronv2:security_group_port_bindings(id, sg), neutronv2:security_groups(sg,name='dmz')" --name dmz_server
-
-echo "Create dmz_placement_error rule in policy 'test'"
-openstack congress policy rule create test "dmz_placement_error(id) :- nova:servers(id,name,hostId,status,tenant_id,user_id,image,flavor,az,hh), not glancev2:tags(image,'dmz'), dmz_server(id)" --name dmz_placement_error
-
-echo "Create image cirros1 with non-dmz image"
-image=$(openstack image list | awk "/ cirros-0.3.3-x86_64 / { print \$2 }")
-if [ -z $image ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64 --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
-fi
-
-echo "Create image cirros2 with dmz image"
-image=$(openstack image list | awk "/ cirros-0.3.3-x86_64-dmz / { print \$2 }")
-if [ -z $image ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64-dmz --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
-fi
-
-echo "Get image ID of cirros dmz image"
-IMAGE_ID=$(glance image-list | awk "/ cirros-0.3.3-x86_64-dmz / { print \$2 }")
-
-echo "Add 'dmz' image tag to the cirros dmz image"
-glance --os-image-api-version 2 image-tag-update $IMAGE_ID "dmz"
-
-get_external_net
-
-echo "Create floating IP for external subnet"
-FLOATING_IP_ID=$(neutron floatingip-create $EXTERNAL_NETWORK_NAME | awk "/ id / { print \$4 }")
-FLOATING_IP=$(neutron floatingip-show $FLOATING_IP_ID | awk "/ floating_ip_address / { print \$4 }" | cut -d - -f 1)
-# Save ID to pass to cleanup script
-echo "FLOATING_IP_ID=$FLOATING_IP_ID" >/tmp/TEST_VARS.sh
-
-echo "Create internal network"
-if [ $(neutron net-list | awk "/ test_internal / { print \$2 }") ]; then unclean; fi
-neutron net-create test_internal
-
-echo "Create internal subnet"
-neutron subnet-create test_internal 10.0.0.0/24 --name test_internal --gateway 10.0.0.1 --enable-dhcp --allocation-pool start=10.0.0.2,end=10.0.0.254 --dns-nameserver 8.8.8.8
-
-echo "Create router"
-if [ $(neutron router-list | awk "/ test_router / { print \$2 }") ]; then unclean; fi
-neutron router-create test_router
-
-echo "Create router gateway"
-neutron router-gateway-set test_router $EXTERNAL_NETWORK_NAME
-
-echo "Add router internal for internal network"
-neutron router-interface-add test_router subnet=test_internal
-
-COUNTER=1
-RESULT="Failed!"
-until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
- echo "Get the internal network ID: try" $COUNTER
- test_internal_NET=$(neutron net-list | awk "/ test_internal / { print \$2 }")
- if [ "$test_internal_NET" != "" ]; then RESULT="Success!"; fi
- let COUNTER+=1
- sleep 10
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Create a security group 'dmz'"
-if [ $(neutron security-group-list | awk "/ dmz / { print \$2 }") ]; then unclean; fi
-neutron security-group-create dmz
-if [ -z $(neutron security-group-list | awk "/ dmz / { print \$2 }") ]; then
- echo "Unable to create security group"
- fail
-fi
-
-echo "Create security group ingress rule for 'dmz'"
-neutron security-group-rule-create --direction ingress dmz
-
-echo "Boot cirros1 with non-dmz image"
-nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$test_internal_NET --security-groups dmz cirros1
-
-echo "Get cirros1 instance ID"
-test_cirros1_ID=$(openstack server list | awk "/ cirros1 / { print \$2 }")
-
-echo "Wait for cirros1 to go ACTIVE"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- status=$(openstack server show $test_cirros1_ID | awk "/ status / { print \$4 }")
- if [[ "$status" == "ACTIVE" ]]; then RESULT="Test Success!"; fi
- let COUNTER-=1
- sleep 5
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Associate floating IP to cirros1"
-nova floating-ip-associate cirros1 $FLOATING_IP
-
-echo "Boot cirros2 with dmz image"
-nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64-dmz --nic net-id=$test_internal_NET --security-groups dmz cirros2
-test_cirros2_ID=$(nova list | awk "/ cirros2 / { print \$2 }")
-if [ -z $test_cirros1_ID ]; then
- echo "Unable to boot cirros2"
- fail
-fi
-
-echo "Wait 5 seconds for Congress polling to occur at least once"
-sleep 5
-
-echo "Verify cirros1 and cirros2 IDs are in the Congress policy 'test' table 'dmz_server'"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- openstack congress policy row list test dmz_server
- dmz_cirros1=$(openstack congress policy row list test dmz_server | awk "/ $test_cirros1_ID / { print \$2 }")
- dmz_cirros2=$(openstack congress policy row list test dmz_server | awk "/ $test_cirros2_ID / { print \$2 }")
- if [[ "$dmz_cirros1" == "$test_cirros1_ID" && "$dmz_cirros2" == "$test_cirros2_ID" ]]; then RESULT="Test Success!"; fi
- let COUNTER-=1
- sleep 5
-done
-echo "dmz_server table entries present for cirros1, cirros2:" $RESULT
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Verify cirros1 ID is in the Congress policy 'test' table 'dmz_placement_error'"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- openstack congress policy row list test dmz_placement_error
- dmz_cirros1=$(openstack congress policy row list test dmz_placement_error | awk "/ $test_cirros1_ID / { print \$2 }")
- if [ "$dmz_cirros1" == "$test_cirros1_ID" ]; then RESULT="Test Success!"; fi
- let COUNTER-=1
- sleep 5
-done
-echo "dmz_placement_error table entry present for cirros2:" $RESULT
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Create reactive 'paused_dmz_placement_error' rule in policy 'test'"
-openstack congress policy rule create test "execute[nova:servers.pause(id)] :- dmz_placement_error(id), nova:servers(id,status='ACTIVE')" --name paused_dmz_placement_error
-
-echo "Verify cirros1 is paused"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- nova list
- cirros1_status=$(nova list | awk "/ cirros1 / { print \$6 }")
- if [ "$cirros1_status" == "PAUSED" ]; then RESULT="Test Success!"; fi
- let COUNTER-=1
- sleep 5
-done
-echo "Verify cirros1 is paused:" $RESULT
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-set +x #echo off
-
-pass
+#!/bin/bash
+# Copyright 2015-2016 AT&T Intellectual Property, Inc
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+# What this is: An OpenStack Congress policy test. Sets up and validates policy
+# creation and execution for:
+# 1) Identifying VMs connected to a DMZ (currently identified through a
+# specifically-named security group)
+# 2) Identifying VMs connected per (1), which are by policy not allowed to be
+# (currently implemented through an image tag intended to identify images
+# that are "authorized" i.e. tested and secure, to be DMZ-connected)
+# 3) Reactively enforce the dmz placement rule by pausing VMs found to be in
+# violation of the policy.
+#
+# Status: this is a work in progress, under test.
+#
+# Prequisite: OPFNV installed per JOID or Apex installer
+# - OpenStack CLI environment variables setup
+# How to use:
+# # Create Congress policy and resources that exercise policy
+# $ bash dmz.sh
+# # After test, cleanup
+# $ bash dmz-clean.sh
+
+pass() {
+ echo "Hooray!"
+ set +x #echo off
+ exit 0
+}
+
+# Use this to trigger fail() at the right places
+# if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+fail() {
+ echo "Test Failed!"
+ set +x
+ exit 1
+}
+
+unclean() {
+ echo "Unclean environment!"
+ fail
+}
+
+if [ $# -eq 1 ]; then
+ if [ $1 == "debug" ]; then
+ set -x #echo on
+ fi
+fi
+
+# Find external network if any, and details
+function get_external_net () {
+ echo "Find external network"
+ LINE=4
+ ID=$(openstack network list | awk "NR==$LINE{print \$2}")
+ while [[ $ID ]]
+ do
+ if [[ $(openstack network show $ID | awk "/ router/ { print \$4 }") == "External" ]]; then break; fi
+ ((LINE+=1))
+ ID=$(openstack network list | awk "NR==$LINE{print \$2}")
+ done
+ if [[ $ID ]]; then
+ EXTERNAL_NETWORK_NAME=$(openstack network show $ID | awk "/ name / { print \$4 }")
+ EXTERNAL_SUBNET_ID=$(openstack network show $EXTERNAL_NETWORK_NAME | awk "/ subnets / { print \$4 }")
+ else
+ echo "External network not found"
+ echo "Create external network"
+ neutron net-create public --router:external
+ EXTERNAL_NETWORK_NAME="public"
+ echo "Create external subnet"
+ neutron subnet-create public 192.168.10.0/24 --name public --enable_dhcp=False --allocation_pool start=192.168.10.6,end=192.168.10.49 --gateway 192.168.10.1
+ EXTERNAL_SUBNET_ID=$(openstack subnet show public | awk "/ id / { print \$4 }")
+ fi
+}
+
+echo "Create Congress policy 'test'"
+if [ $(openstack congress policy show test | awk "/ id / { print \$4 }") ]; then unclean; fi
+openstack congress policy create test
+
+echo "Create dmz_server rule in policy 'test'"
+openstack congress policy rule create test "dmz_server(x) :- nova:servers(id=x,status='ACTIVE'), neutronv2:ports(id, device_id, status='ACTIVE'), neutronv2:security_group_port_bindings(id, sg), neutronv2:security_groups(sg,name='dmz')" --name dmz_server
+
+echo "Create dmz_placement_error rule in policy 'test'"
+openstack congress policy rule create test "dmz_placement_error(id) :- nova:servers(id,name,hostId,status,tenant_id,user_id,image,flavor,az,hh), not glancev2:tags(image,'dmz'), dmz_server(id)" --name dmz_placement_error
+
+echo "Create image cirros1 with non-dmz image"
+image=$(openstack image list | awk "/ cirros-0.3.3-x86_64 / { print \$2 }")
+if [ -z $image ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64 --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
+fi
+
+echo "Create image cirros2 with dmz image"
+image=$(openstack image list | awk "/ cirros-0.3.3-x86_64-dmz / { print \$2 }")
+if [ -z $image ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64-dmz --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
+fi
+
+echo "Get image ID of cirros dmz image"
+IMAGE_ID=$(glance image-list | awk "/ cirros-0.3.3-x86_64-dmz / { print \$2 }")
+
+echo "Add 'dmz' image tag to the cirros dmz image"
+glance --os-image-api-version 2 image-tag-update $IMAGE_ID "dmz"
+
+get_external_net
+
+echo "Create floating IP for external subnet"
+FLOATING_IP_ID=$(neutron floatingip-create $EXTERNAL_NETWORK_NAME | awk "/ id / { print \$4 }")
+FLOATING_IP=$(neutron floatingip-show $FLOATING_IP_ID | awk "/ floating_ip_address / { print \$4 }" | cut -d - -f 1)
+# Save ID to pass to cleanup script
+echo "FLOATING_IP_ID=$FLOATING_IP_ID" >/tmp/TEST_VARS.sh
+
+echo "Create internal network"
+if [ $(neutron net-list | awk "/ test_internal / { print \$2 }") ]; then unclean; fi
+neutron net-create test_internal
+
+echo "Create internal subnet"
+neutron subnet-create test_internal 10.0.0.0/24 --name test_internal --gateway 10.0.0.1 --enable-dhcp --allocation-pool start=10.0.0.2,end=10.0.0.254 --dns-nameserver 8.8.8.8
+
+echo "Create router"
+if [ $(neutron router-list | awk "/ test_router / { print \$2 }") ]; then unclean; fi
+neutron router-create test_router
+
+echo "Create router gateway"
+neutron router-gateway-set test_router $EXTERNAL_NETWORK_NAME
+
+echo "Add router internal for internal network"
+neutron router-interface-add test_router subnet=test_internal
+
+COUNTER=1
+RESULT="Failed!"
+until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
+ echo "Get the internal network ID: try" $COUNTER
+ test_internal_NET=$(neutron net-list | awk "/ test_internal / { print \$2 }")
+ if [ "$test_internal_NET" != "" ]; then RESULT="Success!"; fi
+ let COUNTER+=1
+ sleep 10
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Create a security group 'dmz'"
+if [ $(neutron security-group-list | awk "/ dmz / { print \$2 }") ]; then unclean; fi
+neutron security-group-create dmz
+if [ -z $(neutron security-group-list | awk "/ dmz / { print \$2 }") ]; then
+ echo "Unable to create security group"
+ fail
+fi
+
+echo "Create security group ingress rule for 'dmz'"
+neutron security-group-rule-create --direction ingress dmz
+
+echo "Boot cirros1 with non-dmz image"
+nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$test_internal_NET --security-groups dmz cirros1
+
+echo "Get cirros1 instance ID"
+test_cirros1_ID=$(openstack server list | awk "/ cirros1 / { print \$2 }")
+
+echo "Wait for cirros1 to go ACTIVE"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ status=$(openstack server show $test_cirros1_ID | awk "/ status / { print \$4 }")
+ if [[ "$status" == "ACTIVE" ]]; then RESULT="Test Success!"; fi
+ let COUNTER-=1
+ sleep 5
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Associate floating IP to cirros1"
+nova floating-ip-associate cirros1 $FLOATING_IP
+
+echo "Boot cirros2 with dmz image"
+nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64-dmz --nic net-id=$test_internal_NET --security-groups dmz cirros2
+test_cirros2_ID=$(nova list | awk "/ cirros2 / { print \$2 }")
+if [ -z $test_cirros1_ID ]; then
+ echo "Unable to boot cirros2"
+ fail
+fi
+
+echo "Wait 5 seconds for Congress polling to occur at least once"
+sleep 5
+
+echo "Verify cirros1 and cirros2 IDs are in the Congress policy 'test' table 'dmz_server'"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ openstack congress policy row list test dmz_server
+ dmz_cirros1=$(openstack congress policy row list test dmz_server | awk "/ $test_cirros1_ID / { print \$2 }")
+ dmz_cirros2=$(openstack congress policy row list test dmz_server | awk "/ $test_cirros2_ID / { print \$2 }")
+ if [[ "$dmz_cirros1" == "$test_cirros1_ID" && "$dmz_cirros2" == "$test_cirros2_ID" ]]; then RESULT="Test Success!"; fi
+ let COUNTER-=1
+ sleep 5
+done
+echo "dmz_server table entries present for cirros1, cirros2:" $RESULT
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Verify cirros1 ID is in the Congress policy 'test' table 'dmz_placement_error'"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ openstack congress policy row list test dmz_placement_error
+ dmz_cirros1=$(openstack congress policy row list test dmz_placement_error | awk "/ $test_cirros1_ID / { print \$2 }")
+ if [ "$dmz_cirros1" == "$test_cirros1_ID" ]; then RESULT="Test Success!"; fi
+ let COUNTER-=1
+ sleep 5
+done
+echo "dmz_placement_error table entry present for cirros2:" $RESULT
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Create reactive 'paused_dmz_placement_error' rule in policy 'test'"
+openstack congress policy rule create test "execute[nova:servers.pause(id)] :- dmz_placement_error(id), nova:servers(id,status='ACTIVE')" --name paused_dmz_placement_error
+
+echo "Verify cirros1 is paused"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ nova list
+ cirros1_status=$(nova list | awk "/ cirros1 / { print \$6 }")
+ if [ "$cirros1_status" == "PAUSED" ]; then RESULT="Test Success!"; fi
+ let COUNTER-=1
+ sleep 5
+done
+echo "Verify cirros1 is paused:" $RESULT
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+set +x #echo off
+
+pass
diff --git a/tests/smtp_ingress.sh b/tests/smtp_ingress.sh
index 5c0e766..555a8f4 100644
--- a/tests/smtp_ingress.sh
+++ b/tests/smtp_ingress.sh
@@ -1,172 +1,172 @@
-#!/bin/bash
-# Copyright 2015-2016 AT&T Intellectual Property, Inc
-#
-# Licensed under the Apache License, Version 2.0 (the "License");
-# you may not use this file except in compliance with the License.
-# You may obtain a copy of the License at
-#
-# http://www.apache.org/licenses/LICENSE-2.0
-#
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS,
-# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-# See the License for the specific language governing permissions and
-# limitations under the License.
-#
-
-# What this is: An OpenStack Congress policy test. Sets up and validates policy
-# creation and execution for:
-# 1) Identifying VMs that have STMP (TCP port 25) open for ingress.
-#
-# Status: this is a work in progress, under test.
-#
-# Prequisite: OPFNV installed per JOID or Apex installer
-# - OpenStack CLI environment variables setup
-# How to use:
-# # Create Congress policy and resources that exercise policy
-# $ bash smtp_ingress.sh
-# # After test, cleanup
-# $ bash smtp_ingress-clean.sh
-
-pass() {
- echo "Hooray!"
- set +x #echo off
- exit 0
-}
-
-# Use this to trigger fail() at the right places
-# if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-fail() {
- echo "Test Failed!"
- set +x #echo off
- exit 1
-}
-
-unclean() {
- echo "Unclean environment!"
- fail
-}
-
-if [ $# -eq 1 ]; then
- if [ $1 == "debug" ]; then
- set -x #echo on
- fi
-fi
-
-# Find external network if any, and details
-function get_external_net () {
- echo "Find external network"
- LINE=4
- ID=$(openstack network list | awk "NR==$LINE{print \$2}")
- while [[ $ID ]]
- do
- if [[ $(openstack network show $ID | awk "/ router:external / { print \$4 }") == "External" ]]; then break; fi
- ((LINE+=1))
- ID=$(openstack network list | awk "NR==$LINE{print \$2}")
- done
- if [[ $ID ]]; then
- EXTERNAL_NETWORK_NAME=$(openstack network show $ID | awk "/ name / { print \$4 }")
- EXTERNAL_SUBNET_ID=$(openstack network show $EXTERNAL_NETWORK_NAME | awk "/ subnets / { print \$4 }")
- else
- echo "External network not found"
- echo "Create external network"
- neutron net-create public --router:external
- EXTERNAL_NETWORK_NAME="public"
- echo "Create external subnet"
- neutron subnet-create public 192.168.10.0/24 --name public --enable_dhcp=False --allocation_pool start=192.168.10.6,end=192.168.10.49 --gateway 192.168.10.1
- EXTERNAL_SUBNET_ID=$(openstack subnet show public | awk "/ id / { print \$4 }")
- fi
-}
-
-echo "Create Congress policy 'test'"
-if [[ $(openstack congress policy show test | awk "/ id / { print \$4 }") ]]; then unclean; fi
-openstack congress policy create test
-
-echo "Create smtp_ingress rule in policy 'test'"
-openstack congress policy rule create test "smtp_ingress(x) :- nova:servers(id=x,status='ACTIVE'), neutronv2:ports(port_id, status='ACTIVE'), neutronv2:security_groups(sg, tenant_id, sgn, sgd), neutronv2:security_group_port_bindings(port_id, sg), neutronv2:security_group_rules(sg, rule_id, tenant_id, remote_group_id, 'ingress', ethertype, 'tcp', port_range_min, port_range_max, remote_ip), lt(port_range_min, 26), gt(port_range_max, 24)" --name smtp_ingress
-
-echo "Create image cirros1"
-image=$(openstack image list | awk "/ cirros-0.3.3-x86_64 / { print \$2 }")
-if [ "$image" == "" ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64 --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
-fi
-
-get_external_net
-
-echo "Create floating IP for external subnet"
-FLOATING_IP_ID=$(neutron floatingip-create $EXTERNAL_NETWORK_NAME | awk "/ id / { print \$4 }")
-FLOATING_IP=$(neutron floatingip-show $FLOATING_IP_ID | awk "/ floating_ip_address / { print \$4 }" | cut -d - -f 1)
-# Save ID to pass to cleanup script
-echo "FLOATING_IP_ID=$FLOATING_IP_ID" >/tmp/TEST_VARS.sh
-
-echo "Create internal network"
-if [[ $(neutron net-list | awk "/ test_internal / { print \$2 }") ]]; then unclean; fi
-neutron net-create test_internal
-
-echo "Create internal subnet"
-neutron subnet-create test_internal 10.0.0.0/24 --name test_internal --gateway 10.0.0.1 --enable-dhcp --allocation-pool start=10.0.0.2,end=10.0.0.254 --dns-nameserver 8.8.8.8
-
-echo "Create router"
-if [[ $(neutron router-list | awk "/ test_router / { print \$2 }") ]]; then unclean; fi
-neutron router-create test_router
-
-echo "Create router gateway"
-neutron router-gateway-set test_router $EXTERNAL_NETWORK_NAME
-
-echo "Add router internal for internal network"
-neutron router-interface-add test_router subnet=test_internal
-
-COUNTER=1
-RESULT="Failed!"
-until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
- echo "Get the internal network ID: try" $COUNTER
- test_internal_NET=$(neutron net-list | awk "/ test_internal / { print \$2 }")
- if [ "$test_internal_NET" != "" ]; then RESULT="Success!"; fi
- let COUNTER+=1
- sleep 10
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Create a security group 'smtp_ingress'"
-if [[ $(neutron security-group-list | awk "/ smtp_ingress / { print \$2 }") ]]; then unclean; fi
-neutron security-group-create smtp_ingress
-
-echo "Create security group ingress rule for 'smtp_ingress'"
-neutron security-group-rule-create --direction ingress --protocol=TCP --port-range-min=25 --port-range-max=25 smtp_ingress
-
-echo "Boot cirros1 with smtp_ingress security group"
-nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$test_internal_NET --security-groups smtp_ingress cirros1
-
-echo "Get cirros1 instance ID"
-test_cirros1_ID=$(openstack server list | awk "/ cirros1 / { print \$2 }")
-
-echo "Wait for cirros1 to go ACTIVE"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- status=$(openstack server show $test_cirros1_ID | awk "/ status / { print \$4 }")
- if [[ "$status" == "ACTIVE" ]]; then RESULT="Test Success!"; fi
- let COUNTER-=1
- sleep 5
-done
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-echo "Associate floating IP to cirros1"
-nova floating-ip-associate cirros1 $FLOATING_IP
-
-echo "Verify cirros1 is in the Congress policy 'test' table 'smtp_ingress'"
-COUNTER=5
-RESULT="Test Failed!"
-until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
- openstack congress policy row list test smtp_ingress
- cirros1_ID=$(openstack congress policy row list test smtp_ingress | awk "/ $test_cirros1_ID / { print \$2 }")
- if [ "$cirros1_ID" == "$test_cirros1_ID" ]; then RESULT="Test Success!"
- fi
- let COUNTER-=1
- sleep 10
-done
-echo $RESULT
-if [ "$RESULT" == "Test Failed!" ]; then fail; fi
-
-set +x #echo off
-
-pass
+#!/bin/bash
+# Copyright 2015-2016 AT&T Intellectual Property, Inc
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+# What this is: An OpenStack Congress policy test. Sets up and validates policy
+# creation and execution for:
+# 1) Identifying VMs that have STMP (TCP port 25) open for ingress.
+#
+# Status: this is a work in progress, under test.
+#
+# Prequisite: OPFNV installed per JOID or Apex installer
+# - OpenStack CLI environment variables setup
+# How to use:
+# # Create Congress policy and resources that exercise policy
+# $ bash smtp_ingress.sh
+# # After test, cleanup
+# $ bash smtp_ingress-clean.sh
+
+pass() {
+ echo "Hooray!"
+ set +x #echo off
+ exit 0
+}
+
+# Use this to trigger fail() at the right places
+# if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+fail() {
+ echo "Test Failed!"
+ set +x #echo off
+ exit 1
+}
+
+unclean() {
+ echo "Unclean environment!"
+ fail
+}
+
+if [ $# -eq 1 ]; then
+ if [ $1 == "debug" ]; then
+ set -x #echo on
+ fi
+fi
+
+# Find external network if any, and details
+function get_external_net () {
+ echo "Find external network"
+ LINE=4
+ ID=$(openstack network list | awk "NR==$LINE{print \$2}")
+ while [[ $ID ]]
+ do
+ if [[ $(openstack network show $ID | awk "/ router/ { print \$4 }") == "External" ]]; then break; fi
+ ((LINE+=1))
+ ID=$(openstack network list | awk "NR==$LINE{print \$2}")
+ done
+ if [[ $ID ]]; then
+ EXTERNAL_NETWORK_NAME=$(openstack network show $ID | awk "/ name / { print \$4 }")
+ EXTERNAL_SUBNET_ID=$(openstack network show $EXTERNAL_NETWORK_NAME | awk "/ subnets / { print \$4 }")
+ else
+ echo "External network not found"
+ echo "Create external network"
+ neutron net-create public --router:external
+ EXTERNAL_NETWORK_NAME="public"
+ echo "Create external subnet"
+ neutron subnet-create public 192.168.10.0/24 --name public --enable_dhcp=False --allocation_pool start=192.168.10.6,end=192.168.10.49 --gateway 192.168.10.1
+ EXTERNAL_SUBNET_ID=$(openstack subnet show public | awk "/ id / { print \$4 }")
+ fi
+}
+
+echo "Create Congress policy 'test'"
+if [[ $(openstack congress policy show test | awk "/ id / { print \$4 }") ]]; then unclean; fi
+openstack congress policy create test
+
+echo "Create smtp_ingress rule in policy 'test'"
+openstack congress policy rule create test "smtp_ingress(x) :- nova:servers(id=x,status='ACTIVE'), neutronv2:ports(port_id, status='ACTIVE'), neutronv2:security_groups(sg, tenant_id, sgn, sgd), neutronv2:security_group_port_bindings(port_id, sg), neutronv2:security_group_rules(sg, rule_id, tenant_id, remote_group_id, 'ingress', ethertype, 'tcp', port_range_min, port_range_max, remote_ip), lt(port_range_min, 26), gt(port_range_max, 24)" --name smtp_ingress
+
+echo "Create image cirros1"
+image=$(openstack image list | awk "/ cirros-0.3.3-x86_64 / { print \$2 }")
+if [ "$image" == "" ]; then glance --os-image-api-version 1 image-create --name cirros-0.3.3-x86_64 --disk-format qcow2 --location http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img --container-format bare
+fi
+
+get_external_net
+
+echo "Create floating IP for external subnet"
+FLOATING_IP_ID=$(neutron floatingip-create $EXTERNAL_NETWORK_NAME | awk "/ id / { print \$4 }")
+FLOATING_IP=$(neutron floatingip-show $FLOATING_IP_ID | awk "/ floating_ip_address / { print \$4 }" | cut -d - -f 1)
+# Save ID to pass to cleanup script
+echo "FLOATING_IP_ID=$FLOATING_IP_ID" >/tmp/TEST_VARS.sh
+
+echo "Create internal network"
+if [[ $(neutron net-list | awk "/ test_internal / { print \$2 }") ]]; then unclean; fi
+neutron net-create test_internal
+
+echo "Create internal subnet"
+neutron subnet-create test_internal 10.0.0.0/24 --name test_internal --gateway 10.0.0.1 --enable-dhcp --allocation-pool start=10.0.0.2,end=10.0.0.254 --dns-nameserver 8.8.8.8
+
+echo "Create router"
+if [[ $(neutron router-list | awk "/ test_router / { print \$2 }") ]]; then unclean; fi
+neutron router-create test_router
+
+echo "Create router gateway"
+neutron router-gateway-set test_router $EXTERNAL_NETWORK_NAME
+
+echo "Add router internal for internal network"
+neutron router-interface-add test_router subnet=test_internal
+
+COUNTER=1
+RESULT="Failed!"
+until [[ "$COUNTER" -gt 6 || "$RESULT" == "Success!" ]]; do
+ echo "Get the internal network ID: try" $COUNTER
+ test_internal_NET=$(neutron net-list | awk "/ test_internal / { print \$2 }")
+ if [ "$test_internal_NET" != "" ]; then RESULT="Success!"; fi
+ let COUNTER+=1
+ sleep 10
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Create a security group 'smtp_ingress'"
+if [[ $(neutron security-group-list | awk "/ smtp_ingress / { print \$2 }") ]]; then unclean; fi
+neutron security-group-create smtp_ingress
+
+echo "Create security group ingress rule for 'smtp_ingress'"
+neutron security-group-rule-create --direction ingress --protocol=TCP --port-range-min=25 --port-range-max=25 smtp_ingress
+
+echo "Boot cirros1 with smtp_ingress security group"
+nova boot --flavor m1.tiny --image cirros-0.3.3-x86_64 --nic net-id=$test_internal_NET --security-groups smtp_ingress cirros1
+
+echo "Get cirros1 instance ID"
+test_cirros1_ID=$(openstack server list | awk "/ cirros1 / { print \$2 }")
+
+echo "Wait for cirros1 to go ACTIVE"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ status=$(openstack server show $test_cirros1_ID | awk "/ status / { print \$4 }")
+ if [[ "$status" == "ACTIVE" ]]; then RESULT="Test Success!"; fi
+ let COUNTER-=1
+ sleep 5
+done
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+echo "Associate floating IP to cirros1"
+nova floating-ip-associate cirros1 $FLOATING_IP
+
+echo "Verify cirros1 is in the Congress policy 'test' table 'smtp_ingress'"
+COUNTER=5
+RESULT="Test Failed!"
+until [[ $COUNTER -eq 0 || $RESULT == "Test Success!" ]]; do
+ openstack congress policy row list test smtp_ingress
+ cirros1_ID=$(openstack congress policy row list test smtp_ingress | awk "/ $test_cirros1_ID / { print \$2 }")
+ if [ "$cirros1_ID" == "$test_cirros1_ID" ]; then RESULT="Test Success!"
+ fi
+ let COUNTER-=1
+ sleep 10
+done
+echo $RESULT
+if [ "$RESULT" == "Test Failed!" ]; then fail; fi
+
+set +x #echo off
+
+pass